--[[=============================================================================
    Copyright 2015 Control4 Corporation. All Rights Reserved.
===============================================================================]]

-- This macro is utilized to identify the version string of the driver template version used.
if (TEMPLATE_VERSION ~= nil) then
	TEMPLATE_VERSION.device_specific_commands = "2015.03.31"
end

function ON_DRIVER_INIT.DeviceCommandsTableInit()
	LogTrace("PROTOCOL_DECLARATIONS.DeviceCommandsTableInit()")

	CMDS_AspectRatio = {
		--Aspect COMMANDS PeterChen
		["Auto"]=tohex("12 04 00"),
		["4:3"]=tohex("12 04 02"),
		["16:9"]=tohex("12 04 03"),
		["16:10"]=tohex("12 04 04"),
		["Anamorphic"]=tohex("12 04 05"),
		["Wide"]=tohex("12 04 06"),
		["2.35:1"]=tohex("12 04 07"),
		["Panorama"]=tohex("12 04 08"),

		
	}
	--============================================
	--Projector_Position COMMANDS PeterChen
	--============================================
	CMDS_ProjectorPosition={
		
		["Front Table"]=tohex("12 00 00"),
		["Rear Table"]=tohex("12 00 01"),
		["Rear Ceiling"]=tohex("12 00 02"),
		["Front Ceiling"]=tohex("12 00 03"),
     }					
     --============================================
     --Color_mode COMMANDS PeterChen
     --============================================
     CMDS_ColorMode={
            ["Brightest"]=tohex("12 0B 00"),
            ["Movie"]=tohex("12 0B 01"),
            ["Standard"]=tohex("12 0B 04"),
            ["sRGB/ViewMatch"]=tohex("12 0B 05"),
            ["Dynamic"]=tohex("12 0B 08"),
            ["Rec709"]=tohex("12 0B 09"),
            ["DICOM SIM"]=tohex("12 0B 0a"),
            ["Sports"]=tohex("12 0B 11"),
            ["Photo"]=tohex("12 0B 13"),
            ["Presentation"]=tohex("12 0B 14"),
            ["Gaming"]=tohex("12 0B 12"),
    }
     --============================================
     --Saturation COMMANDS PeterChen
     --============================================
    CMDS_Saturation={
            ["Decrease"]=tohex("12 12 00"),
            ["Increase"]=tohex("12 12 01"),
            ["Get value"]=tohex("12 12 71"),
    }
     --============================================
     --Gain COMMANDS PeterChen
     --============================================
    CMDS_Gain={
            ["Decrease"]=tohex("12 13 00"),
            ["Increase"]=tohex("12 13 01"),
            ["Get value"]=tohex("12 13 72"),
    }
     --============================================
     --Sharpness COMMANDS PeterChen
     --============================================
    CMDS_Sharpness={
            ["Decrease"]=tohex("12 0E 00"),
            ["Increase"]=tohex("12 0E 01"),
            ["Get value"]=tohex("12 0E 6D"),
    }
     --============================================
     --Freeze COMMANDS PeterChen
     --============================================
    CMDS_Freeze={
            ["ON"]=tohex("13 00 01"),
            ["OFF"]=tohex("13 00 00"),
            ["Status"]=tohex("13 00 60"),
    }
    CMDS_HueTint={
            ["Decrease"]=tohex("12 11 00"),
            ["Increase"]=tohex("12 11 01"),
            ["Get value"]=tohex("12 11 70"),
    }
     --============================================
     --Quick_Auto_Search COMMANDS PeterChen
     --============================================
    CMDS_QuickAutoSearch={
            ["ON"]=tohex("13 02 01"),
            ["OFF"]=tohex("13 02 00"),
            ["Status"]=tohex("13 02 62"),
    }
     --============================================
     --Contrast COMMANDS PeterChen
     --============================================
    CMDS_Contrast={
            ["Decrease"]=tohex("12 02 00"),
            ["Increase"]=tohex("12 02 01"),
            ["Get Value"]=tohex("12 02 61"),
    }
     --============================================
     --Brightness COMMANDS PeterChen
     --============================================
    CMDS_Brightness={
            ["Decrease"]=tohex("12 03 00"),
            ["Increase"]=tohex("12 03 01"),
            ["Get Value"]=tohex("12 03 62"),
    }
     --============================================
     --High_Altitude COMMANDS PeterChen
     --============================================
    CMDS_HighAltitude={
            ["OFF"]=tohex("11 0C 00"),
            ["ON"]=tohex("11 0C 01"),
            ["Status"]=tohex("11 0C 6A"),
    }
     --============================================
     --Keystone_Vertical COMMANDS PeterChen
     --============================================
    CMDS_KeystoneVertical={
            ["Decrease"]=tohex("12 0A 00"),
            ["Increase"]=tohex("12 0A 01"),
            ["Get value"]=tohex("12 0A 69"),
    }
     --============================================
     --Keystone_Horizontal COMMANDS PeterChen
     --============================================
    CMDS_KeystoneHorizontal={
            ["Decrease"]=tohex("11 31 00"),
            ["Increase"]=tohex("11 31 01"),
            ["Get value"]=tohex("11 31 8F"),
    }
     --============================================
     --Blank COMMANDS PeterChen
     --============================================
    CMDS_Blank={
            ["ON"]=tohex("12 09 01"),
            ["OFF"]=tohex("12 09 00"),
            ["Status"]=tohex("12 09 68"),
    }
     --============================================
     --Quick_PowerOff COMMANDS PeterChen
     --============================================
    CMDS_QuickPowerOff={
            ["OFF"]=tohex("11 0B 00"),
            ["ON"]=tohex("11 0B 01"),
            ["Status"]=tohex("11 0B 69"),
    }
     --============================================
     --CEC COMMANDS PeterChen
     --============================================
    CMDS_CEC={
            ["OFF"]=tohex("11 2B 00"),
            ["ON"]=tohex("11 2B 01"),
            ["Status"]=tohex("11 2B 89"),
    }
    CMDS_HorizontalPosition={					
            ["Shift Right"]=tohex("12 06 01"),					
            ["Shift Left"]=tohex("12 06 00"),					
            ["Get Value"]=tohex("12 06 65"),					
    }					
						
     --============================================					
     --Vertical_position COMMANDS PeterChen					
     --============================================					
    CMDS_VerticalPosition={					
            ["Shift Up"]=tohex("12 07 00"),					
            ["Shift Down "]=tohex("12 07 01"),					
            ["Get Value"]=tohex("12 07 66"),					
    }					
     --============================================					
     --HDMI_Format COMMANDS PeterChen					
     --============================================					
    CMDS_HDMIFormat={					
            ["RGB"]=tohex("11 28 00"),					
            ["YUV"]=tohex("11 28 01"),					
            ["Auto"]=tohex("11 28 02"),					
            ["Status"]=tohex("11 28 86"),					
    }					
     --============================================					
     --HDMI_Range COMMANDS PeterChen					
     --============================================					
    CMDS_HDMIRange={					
            ["Enhanced"]=tohex("11 29 00"),					
            ["Normal"]=tohex("11 29 01"),					
            ["Auto"]=tohex("11 29 02"),					
            ["Status"]=tohex("11 29 87"),					
    }					
     --============================================
     --Light_Source COMMANDS PeterChen
     --============================================
    CMDS_LightSource={
            ["Normal"]=tohex("11 10 00"),
            ["Eco"]=tohex("11 10 01"),
            ["Dynamic"]=tohex("11 10 02"),
            ["SuperEco"]=tohex("11 10 03"),
            ["Status"]=tohex("11 10 6E"),
    }
     --============================================
     --Color_Temperature COMMANDS PeterChen
     --============================================
    CMDS_ColorTemperature={
            ["Warm"]=tohex("12 08 00"),
            ["Normal"]=tohex("12 08 01"),
            ["Neutral"]=tohex("12 08 02"),
            ["Cool"]=tohex("12 08 03"),
            ["Get Value"]=tohex("12 08 67"),
    }
     --============================================
     --Splash_Screen COMMANDS PeterChen
     --============================================
    CMDS_SplashScreen={
            ["Black"]=tohex("11 0A 00"),
            ["Blue"]=tohex("11 0A 01"),
            ["ViewSonic"]=tohex("11 0A 02"),
            ["Screen Capture"]=tohex("11 0A 03"),
            ["OFF"]=tohex("11 0A 04 6B"),
            ["Status"]=tohex("11 0A 68"),
    }
     --============================================
     --Screen_Color COMMANDS PeterChen
     --============================================
    CMDS_ScreenColor={
            ["OFF"]=tohex("11 32 00"),
            ["Blackboard"]=tohex("11 32 01"),
            ["Greenboard"]=tohex("11 32 02"),
            ["Whiteboard"]=tohex("11 32 03"),
            ["Status"]=tohex("11 32 90"),
    }
    --============================================
     --3DSync COMMANDS PeterChen
     --============================================
    CMDS_Sync3D={
            ["OFF"]=tohex("12 20 00"),
            ["Auto"]=tohex("12 20 01"),
            ["Frame Sequential"]=tohex("12 20 02"),
            ["Frame Packing"]=tohex("12 20 03"),
            ["Top Bottom"]=tohex("12 20 04"),
            ["Side by Side"]=tohex("12 20 05"),
            ["Status"]=tohex("12 20 7F"),
    }
     --============================================
     --Primary_Color COMMANDS PeterChen
     --============================================
    CMDS_PrimaryColor={
            ["R"]=tohex("12 10 00"),
            ["G"]=tohex("12 10 01"),
            ["B"]=tohex("12 10 02"),
            ["C"]=tohex("12 10 03"),
            ["M"]=tohex("12 10 04"),
            ["Y"]=tohex("12 10 05"),
            ["Status"]=tohex("12 10 6F"),
    }
     --============================================
     --OverScan COMMANDS PeterChen
     --============================================
    CMDS_OverScan={
            ["OFF"]=tohex("11 33 00"),
            ["Value 1"]=tohex("11 33 01"),
            ["Value 2"]=tohex("11 33 02"),
            ["Value 3"]=tohex("11 33 03"),
            ["Value 4"]=tohex("11 33 04"),
            ["Value 5"]=tohex("11 33 05"),
            ["Get Value"]=tohex("11 33 91"),
    }
     --============================================
     --RemoteControlCode COMMANDS PeterChen
     --============================================
    CMDS_RemoteControlCode={
            ["code 1"]=tohex("0C 48 00"),
            ["code 2"]=tohex("0C 48 01"),
            ["code 3"]=tohex("0C 48 02"),
            ["code 4"]=tohex("0C 48 03"),
            ["code 5"]=tohex("0C 48 04"),
            ["code 6"]=tohex("0C 48 05"),
            ["code 7"]=tohex("0C 48 06"),
            ["code 8"]=tohex("0C 48 07"),
            ["Status"]=tohex("0C 48 A1"),
    }
     --============================================
     --Brilliant_Color COMMANDS PeterChen
     --============================================
    CMDS_BrilliantColor={
            ["Color 0"]=tohex("12 0F 00"),
            ["Color 1"]=tohex("12 0F 01"),
            ["Color 2"]=tohex("12 0F 02"),
            ["Color 3"]=tohex("12 0F 03"),
            ["Color 4"]=tohex("12 0F 04"),
            ["Color 5"]=tohex("12 0F 05"),
            ["Color 6"]=tohex("12 0F 06"),
            ["Color 7"]=tohex("12 0F 07"),
            ["Color 8"]=tohex("12 0F 08"),
            ["Color 9"]=tohex("12 0F 09"),
            ["Color 10"]=tohex("12 0F 0A"),
            ["Status"]=tohex("12 0F 6E"),
    }
     --============================================
     --Reset COMMANDS PeterChen
     --============================================
    CMDS_Reset={
            ["Reset All Settings"]=tohex("11 02 00"),
            ["Reset Color Settings"]=tohex("11 2A 00"),
    }
end

--[[=============================================================================
    ExecuteCommand Code

    Define any functions for device specific commands (EX_CMD.<command>)
    received from ExecuteCommand that need to be handled by the driver.
===============================================================================]]
--function EX_CMD.NEW_COMMAND(tParams)
--	LogTrace("EX_CMD.NEW_COMMAND")
--	LogTrace(tParams)
--end

function EX_CMD.Aspect(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_AspectRatio[mode]
    PackAndQueueCommand("Aspect", command) 
	
	LogTrace("EX_CMD.Aspect, mode: " .. mode)
end

function EX_CMD.ProjectorPosition(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_ProjectorPosition[mode]
    PackAndQueueCommand("ProjectorPosition", command) 
	
	LogTrace("EX_CMD.ProjectorPosition, mode: " .. mode)
end

function EX_CMD.ColorMode(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_ColorMode[mode]
    PackAndQueueCommand("ColorMode", command) 
	
	LogTrace("EX_CMD.ColorMode, mode: " .. mode)
end

function EX_CMD.Saturation(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_Saturation[mode]
    PackAndQueueCommand("Saturation", command) 
	
	LogTrace("EX_CMD.Saturation, mode: " .. mode)
end

function EX_CMD.Gain(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_Gain[mode]
    PackAndQueueCommand("Gain", command) 
	
	LogTrace("EX_CMD.Gain, mode: " .. mode)
end

function EX_CMD.Sharpness(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_Sharpness[mode]
    PackAndQueueCommand("Sharpness", command) 
	
	LogTrace("EX_CMD.Sharpness, mode: " .. mode)
end

function EX_CMD.Freeze(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_Freeze[mode]
    PackAndQueueCommand("Freeze", command) 
	
	LogTrace("EX_CMD.Freeze, mode: " .. mode)
end

function EX_CMD.HueTint(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_HueTint[mode]
    PackAndQueueCommand("HueTint", command) 
	
	LogTrace("EX_CMD.HueTint, mode: " .. mode)
end

function EX_CMD.KeystoneVertical(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_KeystoneVertical[mode]
    PackAndQueueCommand("KeystoneVertical", command) 
	
	LogTrace("EX_CMD.KeystoneVertical, mode: " .. mode)
end

function EX_CMD.KeystoneHorizontal(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_KeystoneHorizontal[mode]
    PackAndQueueCommand("KeystoneHorizontal", command) 
	
	LogTrace("EX_CMD.KeystoneHorizontal, mode: " .. mode)
end

function EX_CMD.Blank(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_Blank[mode]
    PackAndQueueCommand("Blank", command) 
	
	LogTrace("EX_CMD.Blank, mode: " .. mode)
end

function EX_CMD.QuickPowerOff(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_QuickPowerOff[mode]
    PackAndQueueCommand("QuickPowerOff", command) 
	
	LogTrace("EX_CMD.QuickPowerOff, mode: " .. mode)
end

function EX_CMD.CEC(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_CEC[mode]
    PackAndQueueCommand("CEC", command) 
	
	LogTrace("EX_CMD.CEC, mode: " .. mode)
end

function EX_CMD.HorizontalPosition(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_HorizontalPosition[mode]
    PackAndQueueCommand("HorizontalPosition", command) 
	
	LogTrace("EX_CMD.HorizontalPosition, mode: " .. mode)
end

function EX_CMD.VerticalPosition(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_VerticalPosition[mode]
    PackAndQueueCommand("VerticalPosition", command) 
	
	LogTrace("EX_CMD.VerticalPosition, mode: " .. mode)
end

function EX_CMD.HDMIFormat(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_HDMIFormat[mode]
    PackAndQueueCommand("HDMIFormat", command) 
	
	LogTrace("EX_CMD.HDMIFormat, mode: " .. mode)
end

function EX_CMD.HDMIRange(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_HDMIRange[mode]
    PackAndQueueCommand("HDMIRange", command) 
	
	LogTrace("EX_CMD.HDMIRange, mode: " .. mode)
end

function EX_CMD.LightSource(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_LightSource[mode]
    PackAndQueueCommand("LightSource", command) 
	
	LogTrace("EX_CMD.LightSource, mode: " .. mode)
end

function EX_CMD.ColorTemperature(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_ColorTemperature[mode]
    PackAndQueueCommand("ColorTemperature", command) 
	
	LogTrace("EX_CMD.ColorTemperature, mode: " .. mode)
end

function EX_CMD.SplashScreen(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_SplashScreen[mode]
    PackAndQueueCommand("SplashScreen", command) 
	
	LogTrace("EX_CMD.SplashScreen, mode: " .. mode)
end

function EX_CMD.ScreenColor(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_ScreenColor[mode]
    PackAndQueueCommand("ScreenColor", command) 
	
	LogTrace("EX_CMD.ScreenColor, mode: " .. mode)
end

function EX_CMD.Sync3D(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_Sync3D[mode]
    PackAndQueueCommand("Sync3D", command) 
	
	LogTrace("EX_CMD.Sync3D, mode: " .. mode)
end

function EX_CMD.PrimaryColor(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_PrimaryColor[mode]
    PackAndQueueCommand("PrimaryColor", command) 
	
	LogTrace("EX_CMD.PrimaryColor, mode: " .. mode)
end

function EX_CMD.OverScan(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_OverScan[mode]
    PackAndQueueCommand("OverScan", command) 
	
	LogTrace("EX_CMD.OverScan, mode: " .. mode)
end

function EX_CMD.RemoteControlCode(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_RemoteControlCode[mode]
    PackAndQueueCommand("RemoteControlCode", command) 
	
	LogTrace("EX_CMD.RemoteControlCode, mode: " .. mode)
end

function EX_CMD.BrilliantColor(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_BrilliantColor[mode]
    PackAndQueueCommand("BrilliantColor", command) 
	
	LogTrace("EX_CMD.BrilliantColor, mode: " .. mode)
end

function EX_CMD.Reset(tParams)
    local mode = tParams["Mode"]
    local command = CMDS_Reset[mode]
    PackAndQueueCommand("Reset", command) 
	
	LogTrace("EX_CMD.Reset, mode: " .. mode)
end



